/*
 * Copyright (c) 2019 Asian Information Technology Group
 * All Rights Reserved.
 * NOTICE: USING THIS PROGRAM SOURCE CODE DEEMS TO ACCEPT THE FOLLOWING DISCLAIMER:
 * WE PROVIDE THIS SOFTWARE FOR YOUR REFERENCE ONLY AND EXPRESSLY DISCLAIM ALL EXPRESS, IMPLIED, STATUTORY AND OTHER WARRANTIES OR
 * REPRESENTATIONS, INCLUDING BUT NOT LIMITED TO, THE WARRANTIES OF VIRUS-FREE, PROGRAM ERROR-FREE, MERCHANTABILITY AND FITNESS FOR A
 * PARTICULAR PURPOSE AND NON-INFRINGEMENT OF INTELLECTUAL PROPERTY RIGHTS. WHETHER OR NOT YOU USE THIS SOFTWARE PROGRAM IS AT YOUR
 * DISCRETION AND  WE SHALL BEIN NO EVENT LIABLE FOR ANY DIRECT OR INDIRECT DAMAGES ARISING OUT OF THE USE OF THIS SOFTWARE (INCLUDING BUT
 * NOT LIMITED TO, LOSS OF OPERATING INCOME, PROFITS OR ECONOMIC BENEFITS, LOSS OF DATA OR BUSINESS INTERRUPTION, ETC.), REGARDLESS WHETHER
 * OR NOT  THE DAMAGE IS PREDICTABLE.
 */
/*
 * AITg_humidity_temperature.h
 *
 *  Created on: 2019~1016
 *      Author: AITg
 */

#ifndef SRC_HUMIDITY_TEMPERATURE_H_
#define SRC_HUMIDITY_TEMPERATURE_H_

#define	 I2C_ADDR_HUMIDITY_TEMPERATURE		0x5F
#define  HUMIDITY_TEMPERATURE_I2C_ADDR(act) ((I2C_ADDR_HUMIDITY_TEMPERATURE << 1) | (act))

#define  HUMIDITY_TEMPERATURE_I2C_REG_ADDR_WHO_AM_I		0x0F
#define  HUMIDITY_TEMPERATURE_I2C_REG_ADDR_AV_CONF		0x10
#define  HUMIDITY_TEMPERATURE_I2C_REG_ADDR_CTRL_1		0x20
#define  HUMIDITY_TEMPERATURE_I2C_REG_ADDR_CTRL_2		0x21
#define  HUMIDITY_TEMPERATURE_I2C_REG_ADDR_CTRL_3		0x22
#define  HUMIDITY_TEMPERATURE_I2C_REG_ADDR_STATUS		0x27
#define  HUMIDITY_TEMPERATURE_I2C_REG_ADDR_H_OUT		0x28
#define  HUMIDITY_TEMPERATURE_I2C_REG_ADDR_T_OUT	    0x2A
#define  HUMIDITY_TEMPERATURE_I2C_REG_ADDR_H0_rHx2  	0x30
#define  HUMIDITY_TEMPERATURE_I2C_REG_ADDR_H1_rHx2  	0x31
#define  HUMIDITY_TEMPERATURE_I2C_REG_ADDR_T0_DegCx8  	0x32
#define  HUMIDITY_TEMPERATURE_I2C_REG_ADDR_T1_DegCx8  	0x33
#define  HUMIDITY_TEMPERATURE_I2C_REG_ADDR_T0_T1_MSB  	0x35
#define  HUMIDITY_TEMPERATURE_I2C_REG_ADDR_H0_T0_OUT  	0x36
#define  HUMIDITY_TEMPERATURE_I2C_REG_ADDR_H1_T0_OUT  	0x3A
#define  HUMIDITY_TEMPERATURE_I2C_REG_ADDR_T0_OUT  	    0x3C
#define  HUMIDITY_TEMPERATURE_I2C_REG_ADDR_T1_OUT  	    0x3E

extern int32_t Sensors_Humidity_Temperature_Get_Measured_Value();
#endif /* SRC_HUMIDITY_TEMPERATURE_H_ */
